Loading...
Searching...
No Matches
OBFormat Class Referenceabstract

`#include <openbabel/obconversion.h>`

Inheritance diagram for OBFormat:
[legend]

## Public Types

typedef std::map< const char *, OBPlugin *, CharPtrLess > | PluginMapType
typedef PluginMapType::const_iterator | PluginIterator

## Public Member Functions

| OBFormat ()
const char * | TypeID ()
virtual bool | ReadMolecule (OBBase *, OBConversion *)
virtual bool | ReadChemObject (OBConversion *)
virtual bool | WriteMolecule (OBBase *, OBConversion *)
virtual bool | WriteChemObject (OBConversion *)
virtual const char * | Description ()=0
virtual const char * | TargetClassDescription ()
virtual const std::type_info & | GetType ()
virtual const char * | SpecificationURL ()
virtual const char * | GetMIMEType ()
virtual unsigned int | Flags ()
virtual int | SkipObjects (int, OBConversion *)
virtual OBFormat * | MakeNewInstance ()
int | RegisterFormat (const char *ID, const char *MIME=nullptr)
virtual bool | Display (std::string &txt, const char *param, const char *ID=nullptr)
virtual OBPlugin * | MakeInstance (const std::vector< std::string > &)
virtual void | Init ()
const char * | GetID () const
virtual PluginMapType & | GetMap () const =0

## Static Public Member Functions

static OBFormat * | FormatFromMIME (const char *MIME)
static OBPlugin * | GetPlugin (const char *Type, const char *ID)
static bool | ListAsVector (const char *PluginID, const char *param, std::vector< std::string > &vlist)
static void | List (const char *PluginID, const char *param=nullptr, std::ostream *os=&std::cout)
static std::string | ListAsString (const char *PluginID, const char *param=nullptr)
static std::string | FirstLine (const char *txt)
static PluginIterator | Begin (const char *PluginID)
static PluginIterator | End (const char *PluginID)
static void | LoadAllPlugins ()

## Static Protected Member Functions

static PluginMapType & | PluginMap ()
static PluginMapType & | GetTypeMap (const char *PluginID)
static OBPlugin * | BaseFindType (PluginMapType &Map, const char *ID)

## Protected Attributes

const char * | _id

## Static Protected Attributes

static int | AllPluginsLoaded = 0

## Detailed Description

Base class for file formats.

Two sets of Read and Write functions are specified for each format to handle two different requirements. The "Convert" interface is for use in file format conversion applications. The user interface, a console, a GUI, or another program is kept unaware of the details of the chemistry and does not need to #include mol.h. It is then necessary to manipulate only pointers to OBBase in OBConversion and the user interface, with all the construction and deletion of OBMol etc objects being done in the Format classes or the OB core. The convention with "Covert" interface functions is that chemical objects are made on the heap with new in the ReadChemicalObject() functions and and deleted in WriteChemicalObject() functions

The "API" interface is for programatic use of the OB routines in application programs where mol.h is #included. There is generally no creation or destruction of objects in ReadMolecule() and WriteMolecule() and no restriction on whether the pointers are to the heap or the stack.

Examples
  obconformersearch_default.cpp, and obforcefield_energy.cpp.

## Constructor & Destructor Documentation

## OBFormat()

OBFormat | ( |  | ) |

inline

Default constructor. Registration via RegisterFormat(), not via constructor as in other plugins.

Referenced by OBMoleculeFormat::DeferMolOutput(), FormatFromMIME(), MakeNewInstance(), OBMoleculeFormat::ReadChemObjectImpl(), OBMoleculeFormat::ReadNameIndex(), and OBMoleculeFormat::WriteChemObjectImpl().

## Member Function Documentation

## TypeID()

const char * TypeID | ( |  | ) |

inline virtual

Redefined by each plugin type: "formats", "fingerprints", etc.

Reimplemented from OBPlugin.

Referenced by RegisterFormat().

## ReadMolecule()

virtual bool ReadMolecule | ( | OBBase * | ,
|  | OBConversion * | )

inline virtual

The "API" interface Read function.

Reads a single object. Does not make a new object on the heap; can be used with a pointer to an chem object on the heap or the stack.

Reimplemented in XMLMoleculeFormat.

Referenced by OBMoleculeFormat::DeferMolOutput(), and OBMoleculeFormat::ReadChemObjectImpl().

## ReadChemObject()

virtual bool ReadChemObject | ( | OBConversion * |  | ) |

inline virtual

The "Convert" interface Read function.

Possibly reads multiple new objects on the heap and subjects them to its DoTransformations() function, which may delete them again. Sends result to pConv->AddChemObject()

Reimplemented in OBMoleculeFormat, and XMLMoleculeFormat.

## WriteMolecule()

virtual bool WriteMolecule | ( | OBBase * | ,
|  | OBConversion * | )

inline virtual

The "API" interface Write function.

Writes a single object Does not delete the object; can be used with a pointer to an chem object on the heap or the stack.

Returns
  false on error.

Referenced by OBMoleculeFormat::DoOutputOptions(), OBMoleculeFormat::OutputDeferredMols(), and OBMoleculeFormat::WriteChemObjectImpl().

## WriteChemObject()

virtual bool WriteChemObject | ( | OBConversion * |  | ) |

inline virtual

The "Convert" interface Write function.

Writes a single object Deletes the object after writing

Returns
  false on error

Reimplemented in OBMoleculeFormat, and XMLMoleculeFormat.

## Description()

virtual const char * Description | ( |  | ) |

pure virtual

Information on this format. Printed out in response to -Hxxx option where xxx id the id of the format.

Must be provided by each format class. Can include a list of command line Options. These may be used to construction check boxes, radio buttons etc for GUI interface.

Reimplemented from OBPlugin.

Referenced by Display(), OBConversion::GetNextFormat(), and OBConversion::RegisterOptionParam().

## TargetClassDescription()

const char * TargetClassDescription | ( |  | ) |

virtual

A decription of the chemical object converted by this format.

If not provided, the object type used by the default format is used (usually OBMol).

Referenced by Description(), and OBConversion::ReportNumberConverted().

## GetType()

const type_info & GetType | ( |  | ) |

virtual

Returns
  the type of chemical object used by the format. Defaults to that used by the default format. Useful for checking that a format can handle a particular object.

Reimplemented in OBMoleculeFormat, and XMLMoleculeFormat.

Referenced by Description().

## SpecificationURL()

virtual const char * SpecificationURL | ( |  | ) |

inline virtual

Web address where the format is defined.

Referenced by Display().

## GetMIMEType()

virtual const char * GetMIMEType | ( |  | ) |

inline virtual

Chemical MIME type associated with this file type (if any).

## Flags()

virtual unsigned int Flags | ( |  | ) |

inline virtual

Decribes the capabilities of the format (Read only etc.).

Currently, can be a bitwise OR of any of the following NOTREADABLE READONEONLY NOTWRITABLE WRITEONEONLY DEFAULTFORMAT READBINARY WRITEBINARY READXML

Referenced by Display(), OBConversion::GetNextFormat(), OBMoleculeFormat::ReadChemObjectImpl(), and RegisterFormat().

## SkipObjects()

virtual int SkipObjects | ( | int | ,
|  | OBConversion * | )

inline virtual

Skip past first n objects in input stream (or current one with n=0).

Returns
  1 on success, -1 on error and 0 if not implemented

Reimplemented in XMLBaseFormat.

Referenced by OBConversion::NumInputObjects().

## MakeNewInstance()

virtual OBFormat * MakeNewInstance | ( |  | ) |

inline virtual

Returns
  a pointer to a new instance of the format, or NULL if fails. Normally a single global instance is used but this may cause problems if there are member variables and the format is used in more than one place in the program.

## RegisterFormat()

int RegisterFormat | ( | const char * | ID,
|  | const char * | MIME = nullptr )

Referenced by OBConversion::RegisterFormat().

## Display()

bool Display | ( | std::string & | txt,
|  | const char * | param,
|  | const char * | ID = nullptr )

virtual

Provides a description in txt of the format specified by itr. If param starts with "in", "read", "out" or "write" only the appropriate formats are output. The others return false. If param contains "verbose", the whole description is output.

Reimplemented from OBPlugin.

## FormatFromMIME()

OBFormat * FormatFromMIME | ( | const char * | MIME | ) |

static

Referenced by OBConversion::FormatFromMIME().

The documentation for this class was generated from the following files:

- format.h
- format.cpp